---
title: Using CSS transforms
slug: Web/CSS/CSS_Transforms/Using_CSS_transforms
tags:
  - 3D
  - Advanced
  - CSS
  - CSS Transforms
  - Graphics
  - Guide
  - Rotate
  - Scale
  - Scaling
  - perspective
  - rotation
---
<div>{{CSSRef}}</div>

<p>By modifying the coordinate space, <strong>CSS transforms</strong> change the shape and position of the affected content without disrupting the normal document flow. This guide provides an introduction to using transforms.</p>

<p>CSS transforms are implemented using a set of CSS properties that let you apply affine linear transformations to HTML elements. These transformations include rotation, skewing, scaling, and translation both in the plane and in the 3D space.</p>

<div class="warning">
<p>Only elements positioned by the <a href="/en-US/docs/Web/CSS/CSS_Box_Model">box model</a> can be <code>transform</code>ed. As a rule of thumb, an element is positioned by the box model if it has <code>display: block</code>.</p>
</div>

<h2 id="CSS_transforms_properties">CSS transforms properties</h2>

<p>Two major properties are used to define CSS transforms: {{cssxref("transform")}} and {{cssxref("transform-origin")}}</p>

<dl>
 <dt>{{cssxref("transform-origin")}}</dt>
 <dd>Specifies the position of the origin. By default, it is at the center of the element and can be moved. It is used by several transforms, like rotations, scaling or skewing, that need a specific point as a parameter.</dd>
 <dt>{{cssxref("transform")}}</dt>
 <dd>Specifies the transforms to apply to the element. It is a space-separated list of transforms, which are applied one after the other, as requested by the composition operation. Composite transforms are effectively applied in order from right to left.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Here is an unaltered image of the MDN logo:</p>

<p><img alt="MDN Logo" src="https://mdn.mozillademos.org/files/12539/Screen%20Shot%202016-02-16%20at%2015.53.54.png" style="height: 106px; width: 110px;"></p>

<h3 id="Rotating">Rotating</h3>

<p>Here is the MDN logo rotated 90 degrees from its bottom-left corner.</p>

<pre class="brush: html notranslate">&lt;img style="transform: rotate(90deg);
            transform-origin: bottom left;"
     src="https://mdn.mozillademos.org/files/12539/Screen%20Shot%202016-02-16%20at%2015.53.54.png"&gt;
</pre>

<p>{{EmbedLiveSample('Rotating', 'auto', 240) }}</p>

<h3 id="Skewing_and_translating">Skewing and translating</h3>

<p>Here is the MDN logo, skewed by 10 degrees and translated by 150 pixels on the X-axis.</p>

<pre class="brush: html notranslate">&lt;img style="transform: skewx(10deg) translatex(150px);
            transform-origin: bottom left;"
     src="https://mdn.mozillademos.org/files/12539/Screen%20Shot%202016-02-16%20at%2015.53.54.png"&gt;
</pre>

<p>{{EmbedLiveSample('Skewing_and_translating') }}</p>

<h2 id="3D_specific_CSS_properties">3D specific CSS properties</h2>

<p>Performing CSS transformations in 3D space is a bit more complex. You have to start by configuring the 3D space by giving it a perspective, then you have to configure how your 2D elements will behave in that space.</p>

<h3 id="Perspective">Perspective</h3>

<p>The first element to set is the {{cssxref("perspective")}}. The perspective is what gives us the 3D impression. The farther from the viewer the elements are, the smaller they are.</p>

<p>{{page("/en-US/docs/Web/CSS/perspective", "Setting perspective", 0, 0, 3)}}</p>

<p>The second element to configure is the position of the viewer, with the {{ cssxref("perspective-origin") }} property. By default the perspective is centered on the viewer, which is not always adequate.</p>

<p>{{page("/en-US/docs/Web/CSS/perspective-origin", "Changing the perspective origin", 0, 0, 3)}}</p>

<p>Once you have done this, you can work on the element in the 3D space.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/Events/Using_device_orientation_with_3D_transforms" title="Using Deviceorientation with 3D Transforms">Using device orientation with 3D Transforms</a></li>
 <li><a href="https://desandro.github.com/3dtransforms/">Intro to CSS 3D transforms</a> (Blog post by David DeSandro)</li>
 <li><a href="https://css-transform.moro.es/">CSS Transform Playground</a> (Online tool to visualize CSS Transform functions)</li>
</ul>
